#include <Servo.h>
#include <LiquidCrystal_I2C.h>

LiquidCrystal_I2C mylcd(0x27,16,2); // LCD
Servo myservo1; // rotire brat
Servo myservo2; // ridicare si aplecare brat
Servo myservo3; // indoire brat
Servo myservo4; // deschidere si inchidere cleste 
int pos1=90, pos2=90, pos3=90, pos4=90; // pozitii initiale ale servomotoarelor
int prev_pos1=90, prev_pos2=90, prev_pos3=90, prev_pos4=90; // pozitii anterioare efectuarii miscarii pentru fiecare servomotor
const int right_X = A2; // miscarea pe axa X a joystick-ului din dreapta este conectata la pin-ul A2
const int right_Y = A5; // miscarea pe axa Y a joystick-ului din dreapta este conectata la pin-ul A5
const int right_key = 7; // joystick-ul din dreapta e conectat la pin-ul 7
const int left_X = A3; // miscarea pe axa X a joystick-ului din stanga este conectata la pin-ul A3
const int left_Y = A4; // miscarea pe axa Y a joystick-ului din stanga este conectata la pin-ul A4
const int left_key = 8; // joystick-ul din stanga e conectat la pin-ul 8
int x1,y1,z1; // valorile citite de la joystick-uri
int x2,y2,z2;
int last_x1, last_x2, last_y1, last_y2; // valorile citite la miscarea anterioara de pe joysick-uri

void claw() {
  if(x1<50) // daca joystick-ul din stanga este miscat la dreapta
  {
    prev_pos4=pos4; // se salveaza pozitia precedenta a servomotorului 4
    pos4=pos4+1;  // se actualizeaza pozitia servomotorului
    myservo4.write(pos4); // se dechide clestele
    delay(5);
    if(pos4>120) // limiteaza deschiderea clestelui
    {
      pos4=120;
    }
  }

  if(x1>1000) // daca joystick-ul din stanga este miscat la stanga
  {
    prev_pos4=pos4; // se salveaza pozitia precedenta a servomotorului 4
    pos4=pos4-1; // se actualizeaza pozitia servomotorului
    myservo4.write(pos4); // se inchide clestele
    delay(5);
    if(pos4<45) // limiteaza inchiderea clestelui
    {
      pos4=45;
    }
  }
}

void turn() {
  if(x2<50) // daca joystick-ul din dreapta este miscat la stanga
  {
    prev_pos1=pos1; // se salveaza pozitia precedenta a servomotorului 1
    pos1=pos1+1; // se actualizeaza pozitia servomotorului
    myservo1.write(pos1); // bratul se roteste la stanga
    delay(5);
    if(pos1>180) //limiteaza unghiul de rotatie
    {
      pos1=180;
    }
  }

  if(x2>1000) // daca joystick-ul din dreapta este miscat la dreapta
  {
    prev_pos1=pos1; // se salveaza pozitia precedenta a servomotorului 1
    pos1=pos1-1; // se actualizeaza pozitia servomotorului
    myservo1.write(pos1); // bratul se roteste la dreapta
    delay(5);
    if(pos1<1) // limiteaza unghiul de rotatie
    {
      pos1=1;
    }
  }
}

void upper_arm() {
  if(y1<50) // daca joystick-ul din stanga este miscat in jos 
  {
    prev_pos3=pos3; // se salveaza pozitia precedenta a servomotorului 3
    pos3=pos3-1; // se actualizeaza pozitia servomotorului
    myservo3.write(pos3); // bratul va cobori
    delay(5);
    if(pos3<1) // limiteaza unghiul de coborare
    {
    pos3=1;
    }
  }
  if(y1>1000) // daca joystick-ul din stanga este miscat in sus
  {
    prev_pos3=pos3; // se salveaza pozitia precedenta a servomotorului 3
    pos3=pos3+1; // se actualizeaza pozitia servomotorului
    myservo3.write(pos3); // bratul va urca
    delay(5);
    if(pos3>135) // limiteaza unghiul de urcare
    {
      pos3=135;
    }
  }
}

void lower_arm() {
  if(y2>1000) // daca joystick-ul din dreapta este miscat in jos
  {
    prev_pos2=pos2; // se salveaza pozitia precedenta a servomotorului 2
    pos2=pos2-1; // se actualizeaza pozitia servomotorului
    myservo2.write(pos2); // bratul se va trage inapoi
    delay(5);
    if(pos2<25) // limiteaza unghiul de retragere
    {
      pos2=25;
    }
  }

  if(y2<50) // daca joystick-ul din dreapta este miscat in sus
  {
    prev_pos2=pos2; // se salveaza pozitia precedenta a servomotorului 2
    pos2=pos2+1; // se actualizeaza pozitia servomotorului
    myservo2.write(pos2); // bratul se va intinde
    delay(5);
    if(pos2>180) // limiteaza unghiul de intindere
    {
      pos2=180;
    }
  }
}

void setup() {
  // setarea lcd-ului
  mylcd.init();
  mylcd.backlight();

  // aducerea robotului in pozitia initiala
  myservo1.write(pos1);
  delay(1000);
  myservo2.write(pos2);
  myservo3.write(pos3);
  myservo4.write(pos4);
  delay(1500);

  pinMode(right_key, INPUT); // setarea celor doua joystick-uri ca si input
  pinMode(left_key, INPUT);

  // afisarea unui mesaj de inceput
  mylcd.clear();
  mylcd.setCursor(1-1, 1-1);
  mylcd.print("The arm is ready for use!");

  Serial.begin(9600);
}

void loop() {
  myservo1.attach(3); // seteaza pin-ul de control al servomotorului 1 la D3
  myservo2.attach(5); // seteaza pin-ul de control al servomotorului 2 la D5
  myservo3.attach(6); // seteaza pin-ul de control al servomotorului 3 la D6
  myservo4.attach(9); // seteaza pin-ul de control al servomotorului 4 la D9

  // initializeaza valorile anterioare ale miscarilor efectuate de joystick-uri la cele actuale
  last_x1 = x1;
  last_x2 = x2;
  last_y1 = y1;
  last_y2 = y2;

  x2 = analogRead(right_X); // citeste valoarea X a joystick-ului din dreapta
  y2 = analogRead(right_Y); // citeste valoarea Y a joystick-ului din dreapta
  z2 = digitalRead(right_key); // citeste valoarea Z a joystick-ului din dreapta
  x1 = analogRead(left_X); // citeste valoarea X a joystick-ului din stanga
  y1 = analogRead(left_Y); // citeste valoarea Y a joystick-ului din stanga
  z1 = digitalRead(left_key); // citeste valoarea Z a joystick-ului din stanga

  // apeleaza functia care misca clestele
  claw();

  // daca se incearca deschiderea sau inchiderea clestelelui, dar aceasta nu s-a put realiza
  // se afiseaza un mesaj corespunzator
  if(last_x1!=x1) {
    if(prev_pos4==pos4) {
      if(x1<50) {
        mylcd.clear();
        mylcd.setCursor(1-1, 1-1);
        mylcd.print("Can't open claw!");
      }
      if(x1>1000) {
        mylcd.clear();
        mylcd.setCursor(1-1, 1-1);
        mylcd.print("Can't close claw!");
      }
    }
  }

  // apeleaza functia care roteste bratul
  turn();

  // daca se incearca o miscare de rotatie a bratului, dar aceasta nu s-a put realiza
  // se afiseaza un mesaj corespunzator
  if(last_x2!=x2) {
    if(prev_pos1==pos1) {
      if(x2<50) {
        mylcd.clear();
        mylcd.setCursor(1-1, 1-1);
        mylcd.print("Can't turn left!");
      }
      if(x2>1000) {
        mylcd.clear();
        mylcd.setCursor(1-1, 1-1);
        mylcd.print("Can't turn right!");
      }
    }
  }

  // apeleaza functia care ridica si coboara bratul
  upper_arm();

  // daca se incearca ridicarea sau coborarea bratului, dar aceasta nu s-a put realiza
  // se afiseaza un mesaj corespunzator
  if(last_y1!=y1) {
    if(prev_pos3==pos3) {
      if(y1<50) {
        mylcd.clear();
        mylcd.setCursor(1-1, 1-1);
        mylcd.print("Can't go down!");
      }
      if(y1>1000) {
        mylcd.clear();
        mylcd.setCursor(1-1, 1-1);
        mylcd.print("Can't be lifted!");
      }
    }
  }

  // intinde si trage inapoi bratul
  lower_arm();

  // daca se incearca intinderea sau tragerea inapoi a bratului, dar aceasta nu s-a put realiza
  // se afiseaza un mesaj corespunzator
  if(last_y2!=y2) {
    if(prev_pos2==pos2) {
      if(y2<50) {
        mylcd.clear();
        mylcd.setCursor(1-1, 1-1);
        mylcd.print("Can't draw back!");
      }
      if(y2>1000) {
        mylcd.clear();
        mylcd.setCursor(1-1, 1-1);
        mylcd.print("Can't stretch!");
      }
    }
  }
}
